local MAJOR, MINOR = "LibSimpleTimer", "1.1";
local lib = LibStub:NewLibrary(MAJOR, MINOR);

if not lib then
	return;
end

-- alarm = { duration, callback}
-- callback = function(self, time)

local TIMER_TABLE = TIMER_TABLE or {};	-- name/ID : alarm
local TIMER_TABLE_SIZE = TIMER_TABLE_SIZE or -1; 

local frame;
if not frame then
	frame = CreateFrame("Frame", "SimpleTimerFrame");
end

-------------------------------------------------------------------------------------------------------------------------SimpleTimer

local removeTab = {};
local function update(self, elapsed)
	if TIMER_TABLE_SIZE < 0 then
		TIMER_TABLE_SIZE = 0;
		for _ in pairs(TIMER_TABLE) do
			TIMER_TABLE_SIZE = TIMER_TABLE_SIZE + 1;
		end
	end

	if TIMER_TABLE_SIZE > 0 then
		local time = GetTime();
		for id, alarm in pairs(TIMER_TABLE) do
			alarm.duration = alarm.duration - elapsed;
			if alarm.duration <= 0 then
				if alarm.callBack then
					alarm:callBack(time);
					tinsert(removeTab, id);
				end
			end
		end
		for _, id in ipairs(removeTab) do
			TIMER_TABLE[id] = nil;
			TIMER_TABLE_SIZE = -1;
		end
		wipe(removeTab);
	else
		frame:SetScript("OnUpdate", nil);
	end
end

function lib:SetDurationAlarm(id, duration, callBack)
	if not name then
		name = tostring(timeNow);
	end
	
	local alarm = {};
	alarm.duration = duration or 0;
	alarm.callBack = callBack;
	
	TIMER_TABLE[id] = alarm;
	TIMER_TABLE_SIZE = -1;
	
	if not frame:GetScript("OnUpdate") then
		frame:SetScript("OnUpdate", update);
	end
	
	return id;
end

function lib:CancelTimer(id)
	if TIMER_TABLE[id] then
		TIMER_TABLE[id].callBack = nil;
	end
end

